strict-0.3.2: Strict data types and String IO.

Copyright | (c) 2006-2007 Roman Leshchinskiy
License | BSD-style (see the file LICENSE)
Maintainer | Roman Leshchinskiy <rl@cse.unsw.edu.au>
Stability | experimental
Portability | portable
Safe Haskell | None
Language | Haskell98

Data.Strict.Tuple

Description

Strict pairs.

Same as regular Haskell pairs, but `(x :*: _|_) = (_|_ :*: y) = _|_`

Synopsis

- data Pair a b = !a :!: !b
- type (:!:) = Pair
- fst :: Pair a b -> a
- snd :: Pair a b -> b
- curry :: (Pair a b -> c) -> a -> b -> c
- uncurry :: (a -> b -> c) -> Pair a b -> c

# Documentation

data Pair a b

The type of strict pairs.

Constructors

!a :!: !b infixl 2 |

Instances

(Bounded a, Bounded b) => Bounded (Pair a b) |
(Eq a, Eq b) => Eq (Pair a b) |
(Ord a, Ord b) => Ord (Pair a b) |
(Read a, Read b) => Read (Pair a b) |
(Show a, Show b) => Show (Pair a b) |
(Ix a, Ix b) => Ix (Pair a b) |

type (:!:) = Pair infixl 2

fst :: Pair a b -> a

Extract the first component of a strict pair.

snd :: Pair a b -> b

Extract the second component of a strict pair.

curry :: (Pair a b -> c) -> a -> b -> c

Curry a function on strict pairs.

uncurry :: (a -> b -> c) -> Pair a b -> c

Convert a curried function to a function on strict pairs.